/*************************************************************************/
/*    Copyright (C) 2017 Wizardry and Steamworks - License: GNU GPLv3    */
/*************************************************************************/
function wasKeyValueToObject(a) {
    var o = {};
    a.reduce(function(a, c, i) {
        i = Math.floor(i / 2);
        if (!a[i]) {
            a[i] = [];
        }
        a[i].push(c);
        return a;
    }, []).forEach(function(c, i, a) {
        o[c[0]] = c[1];
    }, o);
    return o;
}

/*************************************************************************/
/*    Copyright (C) 2017 Wizardry and Steamworks - License: GNU GPLv3    */
/*************************************************************************/
function wasKeyValueSet(k, v, data) {
    return data.split('&')
                .map(c => c.split('=')[0] === k ? `${k}=${v}` : c)
                .concat(`${k}=${v}`)
                .filter((e,i,s) => s.indexOf(e) === i)
                .join('&');
}


/*************************************************************************/
/*    Copyright (C) 2017 Wizardry and Steamworks - License: GNU GPLv3    */
/*************************************************************************/
function wasKeyValueGet(k, data) {
    return data.split('&').reduce((a, c) => {
        var s = c.split('=');
        return s[0] === k ? s[1] : a;
    }, '');
}